/*
   Copyright 1991 Inference Corporation
   550 North Continental Blvd.
   El Segundo, CA 90245
   An Unpublished Work - All Rights Reserved.
   CBR Express (TM) Patent Pending.

   RESTRICTED RIGHTS LEGEND
   Use, disclosure or reproduction of this software is subject to the
   conditions contained in the Inference Software License Agreement.
   This software may only be used in conjunction with ART-IM and
   CBR Express.
   
   Use, reproduction or disclosure by the U.S. Government is subject
   to restriction as set forth in the Rights in Technical Data and
   Computer Software clause at 52.227-19.

   The program contained herein is offered solely for the convenience
   of Inference licensees and may be modified by licensee for use with
   Inference programs.  The program is provided "as-is" and is not
   eligible for Inference technical assistance.  Inference assumes no
   obligation to maintain or support this program, nor to insure its
   compatibility with licensee's systems or software.
   INFERENCE HEREBY DISCLAIMS ANY AND ALL WARRANTIES INCLUDING, WITHOUT
   LIMITATION, THE WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
   PARTICULAR PURPOSE.
*/

#include "art.h"
#include "windows.h"
#include "stdarg.h"
#include "wimem.h"

HANDLE hInst=NULL,hAccTable=NULL;
HWND hAppWnd=NULL,hMDIClientWnd=NULL;
BOOL bInEmptyEvents=FALSE,bTraceUpdateBrowsers=NULL;

/*
struct user *cur_user;
struct application *cur_appl;

typedef struct
{
  struct user *cur_user;
  struct application *cur_appl;
} ARTTASK, FAR * LPARTTASK;
*/

int FAR PASCAL LibMain(hModule,wDataSeg,cbHeapSize,lpszCmdLine)
HANDLE hModule;
WORD wDataSeg;
WORD cbHeapSize;
LPSTR lpszCmdLine;
{
  hInst = hModule;
  return(1);
}

void FAR PASCAL AInitialize(void)
{
  static BOOL bCalled=FALSE;

  if (bCalled)
    a_clear();
  else
    {
      bCalled = TRUE;
      a_init();
    }
} /*AInitialize*/

int FAR PASCAL WEP(bSystemExit)
int bSystemExit;
{
  return(1);
}

/*
void AIMakeTaskCurrent(pTask)
LPARTTASK pTask;
{
  cur_user = pTask->cur_user;
  cur_appl = pTask->cur_appl;
}

LPARTTASK FAR PASCAL AOpenTask()
{
  LPARTTASK pTask;

  if (pTask = WiAlloc(sizeof(ARTTASK)))
    {
      pTask->cur_user = (struct user FAR *) WiAlloc(sizeof(struct user));
      pTask->cur_appl = (struct application FAR *) WiAlloc(sizeof(struct application));
    }
  return(pTask);
}

void FAR PASCAL ACloseTask(pTask)
LPARTTASK pTask;
{
  WiFree((LPSTR) pTask->cur_user);
  WiFree((LPSTR) pTask->cur_appl);
  WiFree((LPSTR) pTask);
}
*/

LPSTR FAR PASCAL AEvaluateString(szEval)
LPSTR szEval;
{
  art_string asRet;
  LPSTR szRet;
  HANDLE hMem;

  while (a_enable_restart(a_default_error,"catch_all"))
    {
      a_disable_restart();
      MessageBox(0,"Error in ART-IM.","artcalls.dll",MB_OK | MB_ICONHAND);
      szRet = WiAlloc(4L);
      lstrcpy(szRet,"NIL");
      return(szRet);
    }
  asRet = a_open_string(NULL,"w");
  a_printf(asRet,"%A",a_eval_string(szEval));
  if (szRet = WiAlloc(a_stream_strlen(asRet) + 1L))
    {
      a_stream_strcpy(szRet,asRet);
      a_close(asRet);
    }
  a_disable_restart();
  return(szRet);
} /*AEvaluateString*/

int FAR PASCAL AFreeEvaluateString(szRet)
LPSTR szRet;
{
  WiFree(szRet);
  return(0);
} /*AFreeEvaluateString*/

/*
   I think this works
*/
int fprintf(fp,szFormat,...)
FILE *fp;
LPSTR szFormat;
{
  LPSTR szBuf;
  int iLen;
  va_list marker;
  va_start(marker,szFormat);

  szBuf = WiAlloc(16000L);
  wvsprintf(szBuf,szFormat,marker);
  fputs(szBuf,fp);
  iLen = lstrlen(szBuf);
  WiFree(szBuf);
  va_end(marker);
  return(iLen);
}

int fscanf(i,sz,...)
int i;
LPSTR sz;
{
  MessageBox(0,"fscanf called, can't do this.","artcalls.dll",MB_OK | MB_ICONHAND);
}

int sscanf(i,sz,...)
int i;
LPSTR sz;
{
  MessageBox(0,"sscanf called, can't do this.","artcalls.dll",MB_OK | MB_ICONHAND);
}

void MBox(hwnd,lpszText,bError)
HWND hwnd;
LPSTR lpszText;
BOOL bError;
{
  WORD wFlag;

  if (bError)
    wFlag = MB_ICONEXCLAMATION;
  else
    wFlag = MB_ICONINFORMATION;
  MessageBox(hwnd,lpszText,"ART-IM",MB_OK | wFlag);
} /*MBox*/


